
u[ct_,htm1_] := ((ct/(htm1^gamma))^(1-rho))/(1-rho);
dudct[ct_,htm1_]   := (ct^(-rho))(htm1^(rho gamma - gamma));            (* du/dc *)
dudhtm1[ct_,htm1_] := -gamma (ct^(1-rho)) htm1^(rho gamma - gamma - 1); (* du/dh *)

OmegatRaw[st_,ht_,LifePosn_] := (1/NumOfyShockPoints)*Sum[Vt[R*st+yShockVals[[i]],ht,LifePosn+1],{i,Length[yShockVals]}];

OmegaInvtRaw[st_,ht_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[Infinity]];
  OmegatRawVal = OmegatRaw[st,ht,LifePosn];
  Return[ (OmegatToOmegaInvtMultiply OmegatRawVal)^OmegatToOmegaInvtPower];  
];

ClearAll[Omegat];
Omegat[st_,ht_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  Return[ (OmegaInvtInterpFunc[[LifePosn]][st,ht]^(1/OmegatToOmegaInvtPower))
          /OmegatToOmegaInvtMultiply];
];

OmegastRaw[st_,ht_,LifePosn_] := (1/NumOfyShockPoints)*R*Sum[Vxt[R*st+yShockVals[[i]],ht,LifePosn+1],{i,Length[yShockVals]}];

OmegasInvtRaw[st_,ht_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength, Return[Infinity]];
  OmegastRawVal = OmegastRaw[st,ht,LifePosn];
  If[OmegastRawVal>0,Return[(OmegastRawVal OmegastToOmegasInvtMultiply)^OmegastToOmegasInvtPower]];
  Return[0]      
];

Omegast[st_,ht_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  OmegastInvtInterpVal = Max[0,OmegasInvtInterpFunc[[LifePosn]][st,ht]];
  If[OmegastInvtInterpVal > 0,
      Return[(OmegastInvtInterpVal^(1/OmegastToOmegasInvtPower))
         /OmegastToOmegasInvtMultiply]];
  Return[Infinity];
];

OmegahtRaw[st_,ht_,LifePosn_] := (1/NumOfyShockPoints)*Sum[Vht[R*st+yShockVals[[i]],ht,LifePosn+1],{i,Length[yShockVals]}];

ClearAll[OmegahInvtRaw];
OmegahInvtRaw[st_,ht_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength, Return[Infinity]];
  OmegahtRawVal = OmegahtRaw[st,ht,LifePosn];
  Return[(OmegahtRawVal OmegahtToOmegahInvtMultiply)^OmegahtToOmegahInvtPower]
];

ClearAll[Omegaht];
Omegaht[st_,ht_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  Return[(OmegahInvtInterpFunc[[LifePosn]][st,ht]^(1/OmegahtToOmegahInvtPower))
         /OmegahtToOmegahInvtMultiply];
];


ctRaw[xt_,htm1_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[xt]];
  If[xt < 0, Return[0]];
  ctp1Val = ct[xt,htm1,LifePosn+1];
  ctSearchMax = ctp1Val + (xMax-ctp1Val)*.01;
  ctSearchMin = ctp1Val - ctp1Val*.01;
  ctResults = FindRoot[
    ct == ((htm1^(gamma-rho gamma)) beta (Omegast[xt-ct,htm1+lambda*(ct-htm1),LifePosn] -
              lambda Omegaht[xt-ct,htm1+lambda*(ct-htm1),LifePosn]))^(-1/rho)
  ,{ct,{ctSearchMin,ctSearchMax}}
(*  ,AccuracyGoal->3*)
  ];
  ctUnconstrained = (ct /. ctResults);
  If[ctUnconstrained>xt,xt,ctUnconstrained]
];
  

ct[xt_,htm1_,LifePosn_] := ctInterpFunc[[LifePosn]][xt,htm1];


VInvtRaw[xt_,htm1_,LifePosn_] := Block[{},
  If[LifePosn >    LifeLength,Return[Infinity]];
  If[xt == 0, Return[0]];
  If[LifePosn == LifeLength,Return[u[xt,htm1]]];
  ctVt = ct[xt,htm1,LifePosn];
  VtRawVal = u[ctVt] + beta Omegat[xt-ctVt,htm1+lambda*(ctVt-htm1),LifePosn];
  Return[(VtToVInvtMultiply VtRawVal)^VtToVInvtPower]
];


Vt[xt_,htm1_,LifePosn_] := Block[{},
  If[LifePosn >    LifeLength,Return[0]];
  If[xt == 0, Return[-Infinity]];
  If[LifePosn == LifeLength,Return[u[xt,htm1]]];
  Return[(VInvtInterpFunc[[LifePosn]][xt,htm1]^(1/VtToVInvtPower))
         /VtToVInvtMultiply];
];

VxtRaw[xt_,htm1_,LifePosn_] := Block[{},
    ctVxtVal = ct[xt,htm1,LifePosn];
    Return[
      dudct[ctVxtVal,htm1]+
      beta lambda OmegahtRaw[xt-ctVxtVal,htm1+lambda(ctVxtVal-htm1),LifePosn]];
];

VxInvtRaw[xt_,htm1_,LifePosn_] := 
Block[{},
  If[LifePosn > LifeLength,Return[Infinity]];
  If[xt == 0              ,Return[0]];
  VxtRawVal = VxtRaw[xt,htm1,LifePosn];
  Return[ (VxtToVxInvtMultiply VxtRawVal)^VxtToVxInvtPower];
];


Vxt[xt_,htm1_,LifePosn_] := 
Block[{},
  If[LifePosn >    LifeLength,Return[0]];
  If[xt == 0                 ,Return[Infinity]];
  If[LifePosn == LifeLength,Return[dudct[xt,htm1]]];
  Return[ (VxInvtInterpFunc[[LifePosn]][xt,htm1]^(1/VxtToVxInvtPower))
          /VxtToVxInvtMultiply];
];

VhInvtRaw[xt_,htm1_,LifePosn_] := (* VxtRaw is the derivative of Vt with respect to xt *)
Block[{},
  If[LifePosn >    LifeLength,Return[Infinity]];
  If[xt == 0                 ,Return[0]];
  ctVhtVal = ct[xt,htm1,LifePosn];
  VhtVal = dudhtm1[ctVhtVal,htm1] + beta OmegahtRaw[xt-ctVhtVal,htm1,LifePosn];
  Return[(VhtToVhInvtMultiply VhtVal)^VhtToVhInvtPower];
];


Vht[xt_,htm1_,LifePosn_] := 
Block[{},
  If[LifePosn >    LifeLength,Return[0]];
  If[xt == 0                 ,Return[-Infinity]];
  If[LifePosn == LifeLength,Return[dudhtm1[xt,htm1]]];
  Return[ (VhInvtInterpFunc[[LifePosn]][xt,htm1]^(1/VhtToVhInvtPower))
          /VhtToVhInvtMultiply];
  Return[VhtVal]
];
