<<setup_workspace.m;
<<setup_params.m;
<<setup_grids.m;
<<setup_shocks.m;

<<multicontrol_vars.m;
<<multicontrol_functions.m;

LifePosn = LifeLength;  (* Set LifePosn indicator value to the last period of life *)

xGridBaseline = xGrid;  (* Set up baseline value for state grid xGrid *)

While[LifePosn>0,

Print[LifePosn];

OmegaInvtArgumentList           = AddOutcome[OmegaInvtArgArray,Table[LifePosn,{Length[OmegaInvtArgArray]}]];
OmegaInvtRawResults             = Map[Apply[OmegaInvtRaw,#] &,OmegaInvtArgumentList];
OmegaInvtInterpData[[LifePosn]] = AddOutcome[OmegaInvtArgArray,OmegaInvtRawResults];
OmegaInvtInterpFunc[[LifePosn]] = Interpolation[OmegaInvtInterpData[[LifePosn]],InterpolationOrder->1];

OmegasInvtArgumentList           = AddOutcome[OmegasInvtArgArray,Table[LifePosn,{Length[OmegasInvtArgArray]}]];
OmegasInvtRawResults             = Map[Apply[OmegasInvtRaw,#] &,OmegasInvtArgumentList];
OmegasInvtInterpData[[LifePosn]] = AddOutcome[OmegasInvtArgArray,OmegasInvtRawResults];
OmegasInvtInterpFunc[[LifePosn]] = Interpolation[OmegasInvtInterpData[[LifePosn]],InterpolationOrder->1];

OmegawtArgumentList           = AddOutcome[OmegawtArgArray,Table[LifePosn,{Length[OmegawtArgArray]}]];
OmegawtRawResults             = Map[Apply[OmegawtRaw,#] &,OmegawtArgumentList];
OmegawtInterpData[[LifePosn]] = AddOutcome[OmegawtArgArray,OmegawtRawResults];
OmegawtInterpFunc[[LifePosn]] = Interpolation[OmegawtInterpData[[LifePosn]],InterpolationOrder->1];


OmegaInvOpttArgumentList           = AddOutcome[OmegaInvOpttArgArray,Table[LifePosn,{Length[OmegaInvOpttArgArray]}]];
OmegaInvOpttRawResultsList         = Map[Apply[OmegaInvOpttRaw,#] &,OmegaInvOpttArgumentList];


OmegaInvOpttRawResults  = Transpose[OmegaInvOpttRawResultsList][[1]];
OmegasInvOpttRawResults = Transpose[OmegaInvOpttRawResultsList][[2]];
wtRawResults            = Transpose[OmegaInvOpttRawResultsList][[3]];

OmegaInvOpttInterpData[[LifePosn]] = AddOutcome[OmegaInvOpttArgArray,OmegaInvOpttRawResults];
OmegaInvOpttInterpFunc[[LifePosn]] = Interpolation[OmegaInvOpttInterpData[[LifePosn]],InterpolationOrder->1];

OmegasInvOpttInterpData[[LifePosn]] = AddOutcome[OmegasInvOpttArgArray,OmegasInvOpttRawResults];
OmegasInvOpttInterpFunc[[LifePosn]] = Interpolation[OmegasInvOpttInterpData[[LifePosn]],InterpolationOrder->1];

wtInterpData[[LifePosn]] = AddOutcome[wtArgArray,wtRawResults];
wtInterpFunc[[LifePosn]] = Interpolation[wtInterpData[[LifePosn]],InterpolationOrder->1];

(* 
Now find the point at which the liquidity constraint begins to bind 
*)

If[LifePosn < LifeLength,
  wCenter=wGrid[[Round[Length[wGrid]/2]+1]];
  wList = {wMin,wCenter,wMax};
  BindingPoints = { beta^(1/rho)*OmegasInvOpttInterpFunc[[LifePosn]][0]};
  xGrid = Union[BindingPoints,xGridBaseline];   (* Add the point to the gridpoints *)
  MakeArgArrays[xFunctions];                    (* Reconstruct the ArgArrays *)
];


ctArgumentList           = AddOutcome[ctArgArray,Table[LifePosn,{Length[ctArgArray]}]];
ctRawResults             = Map[Apply[ctRaw,#] &,ctArgumentList];
ctInterpData[[LifePosn]] = AddOutcome[ctArgArray,ctRawResults];
ctInterpFunc[[LifePosn]] = Interpolation[ctInterpData[[LifePosn]],InterpolationOrder->1];

VInvtArgumentList           = AddOutcome[VInvtArgArray,Table[LifePosn,{Length[VInvtArgArray]}]];
VInvtRawResults             = Map[Apply[VInvtRaw,#] &,VInvtArgumentList];
VInvtInterpData[[LifePosn]] = AddOutcome[VInvtArgArray,VInvtRawResults];
VInvtInterpFunc[[LifePosn]] = Interpolation[VInvtInterpData[[LifePosn]],InterpolationOrder->1];

VxInvtArgumentList  = AddOutcome[VxInvtArgArray,Table[LifePosn,{Length[VxInvtArgArray]}]];
VxInvtRawResults    = Map[Apply[VxInvtRaw,#] &,VxInvtArgumentList];
VxInvtInterpData[[LifePosn]] = AddOutcome[VxInvtArgArray,VxInvtRawResults];
VxInvtInterpFunc[[LifePosn]] = Interpolation[VxInvtInterpData[[LifePosn]],InterpolationOrder->1];


LifePosn--;
] (* End While *)

LifePosn++;

PlotctMultContr = 
Plot[
    ct[xt,LifePosn]
	,{xt,xMin,xMax}
    ,ImageSize->{72 6.,72 6./GoldenRatio}
    ,PlotLabel->"ct[xt,1] With Portfolio Choice"
    ,AxesLabel->{"xt","ct[xt,1]"}
    ,PlotRange->All
];
Display[ParentDirectoryString<>"PlotctMultContr.EPS",PlotctMultContr,"EPS"];

PlotwtOfst = 
Plot[
    wt[st,LifePosn]
	,{st,sMin,sMax}
    ,ImageSize->{72 6.,72 6./GoldenRatio}
    ,PlotLabel->"wt[st,1]"
    ,AxesLabel->{"st","wt[st,1]"}
    ,AxesOrigin->{0,0}
    ,PlotRange->{{sMin,sMax},{0,1}}
];
Display[ParentDirectoryString<>"PlotwtOfst.EPS",PlotwtOfst,"EPS"];
