
u[ct_] := (ct^(1-rho))/(1-rho);
dudct[ct_]   := ct^(-rho);

OmegatRaw[st_,wt_,LifePosn_] := 
    (1/(NumOfeShockPoints*NumOfyShockPoints))*
    Sum[Vt[(R+wt*(eVals[[j]]-R))*st+yShockVals[[i]],LifePosn+1]
    ,{i,Length[yShockVals]}
    ,{j,Length[eVals]}
    ];

OmegaInvtRaw[st_,wt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[Infinity]];
  OmegatRawVal = OmegatRaw[st,wt,LifePosn];
  Return[ (OmegatToOmegaInvtMultiply OmegatRawVal)^OmegatToOmegaInvtPower];  
];

ClearAll[Omegat];
Omegat[st_,wt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  Return[ (OmegaInvtInterpFunc[[LifePosn]][st,wt]^(1/OmegatToOmegaInvtPower))
          /OmegatToOmegaInvtMultiply];
];

OmegastRaw[st_,wt_,LifePosn_] := 
    (1/(NumOfeShockPoints*NumOfyShockPoints))*
    Sum[(R+wt*(eVals[[j]]-R))*
    Vxt[(R+wt*(eVals[[j]]-R))*st+yShockVals[[i]],LifePosn+1]
    ,{i,Length[yShockVals]}
    ,{j,Length[eVals]}
    ];

OmegasInvtRaw[st_,wt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength, Return[Infinity]];
  OmegastRawVal = OmegastRaw[st,wt,LifePosn];
  If[OmegastRawVal>0,Return[(OmegastRawVal OmegastToOmegasInvtMultiply)^OmegastToOmegasInvtPower]];
  Return[0]      
];

Omegast[st_,wt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  OmegastInvtInterpVal = Max[0,OmegasInvtInterpFunc[[LifePosn]][st,wt]];
  If[OmegastInvtInterpVal > 0,
      Return[(OmegastInvtInterpVal^(1/OmegastToOmegasInvtPower))
         /OmegastToOmegasInvtMultiply]];
  Return[Infinity];
];


OmegaInvOpttRaw[st_,LifePosn_] := Block[{},
    If[LifePosn == LifeLength,Return[{Infinity,Infinity,0}]];
    If[st == 0,   (* If savings are zero, 'portfolio share' is meaningless; therefore return the adjacent value*)
      wtOpt=OmegaInvOpttRaw[sGrid[[2]],LifePosn][[3]];
      Return[{OmegaInvtInterpFunc[[LifePosn]][0,wtOpt]
             ,OmegasInvtInterpFunc[[LifePosn]][0,wtOpt]
             ,wtOpt}]
      ]; 
	wtOpt = 
	  (wtFind /. 
	    FindRoot[
	        0 == Omegawt[st,wtFind,LifePosn]
	        ,{wtFind,{0,1}}]
	   );
	If[wtOpt > 1,wtOpt =1];
	If[wtOpt < 0,wtOpt =0];
	Omegat0     = Omegat[st,0,LifePosn];
	Omegat1     = Omegat[st,1,LifePosn];
	OmegatwtOpt = Omegat[st,wtOpt,LifePosn];
	
	If[Omegat0  > OmegawtOpt,wtOpt=0;OmegatwtOpt=Omegat0];
	If[Omegat1  > OmegawtOpt,wtOpt=1;OmegatwtOpt=Omegat1];	
    Return[{OmegaInvtInterpFunc[[LifePosn]][st,wtOpt],OmegasInvtInterpFunc[[LifePosn]][st,wtOpt],wtOpt}];
];

OmegaOptt[st_,LifePosn_] := Block[{},
    Return[(OmegaInvOpttInterpFunc[[LifePosn]][st]^(1/OmegaOpttToOmegaInvOpttPower))
           /OmegaOpttToOmegaInvOpttMultiply]; 
    ];

OmegasOptt[st_,LifePosn_] := Block[{},
    Return[(OmegasInvOpttInterpFunc[[LifePosn]][st]^(1/OmegasOpttToOmegasInvOpttPower))
           /OmegasOpttToOmegasInvOpttMultiply]; 
    ];
    

OmegawtRaw[st_,wt_,LifePosn_] := 
    (1/(NumOfeShockPoints*NumOfyShockPoints))*
    Sum[(eVals[[j]]-R)*
    Vxt[(R+wt*(eVals[[j]]-R))*st+yShockVals[[i]],LifePosn+1]
    ,{i,Length[yShockVals]}
    ,{j,Length[eVals]}
    ];


Omegawt[st_,wt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  Return[OmegawtInterpFunc[[LifePosn]][st,wt]];
];

wt[xt_,LifePosn_] := wtInterpFunc[[LifePosn]][xt];

ctRaw[xt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[xt]];
  If[xt < 0, Return[0]];
  ctp1Val = ct[xt,LifePosn+1];
  ctSearchMax = ctp1Val + (xMax-ctp1Val)*.01;
  ctSearchMin = ctp1Val - ctp1Val*.01;
  ctResults = FindRoot[
    ct == beta^(1/rho) OmegasInvOpttInterpFunc[[LifePosn]][xt-ct]
  ,{ct,{ctSearchMin,ctSearchMax}}];
  ctUnconstrained = (ct /. ctResults);
  If[ctUnconstrained>xt,xt,ctUnconstrained]
];
  

ct[xt_,LifePosn_] := ctInterpFunc[[LifePosn]][xt];


VInvtRaw[xt_,LifePosn_] := Block[{},
  If[LifePosn >    LifeLength,Return[Infinity]];
  If[xt == 0, Return[0]];
  If[LifePosn == LifeLength,Return[u[xt]]];
  ctVt = ct[xt,LifePosn];
  VtRawVal = u[ctVt] + beta OmegaOptt[xt-ctVt,LifePosn];
  Return[(VtToVInvtMultiply VtRawVal)^VtToVInvtPower]
];


Vt[xt_,LifePosn_] := Block[{},
  If[LifePosn >    LifeLength,Return[0]];
  If[xt == 0, Return[-Infinity]];
  If[LifePosn == LifeLength,Return[u[xt]]];
  Return[(VInvtInterpFunc[[LifePosn]][xt]^(1/VtToVInvtPower))
         /VtToVInvtMultiply];
];

VxtRaw[xt_,LifePosn_] := Block[{},
    ctVxtVal = ct[xt,LifePosn];
    Return[dudct[ctVxtVal]]
];

VxInvtRaw[xt_,LifePosn_] := 
Block[{},
  If[LifePosn > LifeLength,Return[Infinity]];
  If[xt == 0              ,Return[0]];
  VxtRawVal = VxtRaw[xt,LifePosn];
  Return[ (VxtToVxInvtMultiply VxtRawVal)^VxtToVxInvtPower];
];


Vxt[xt_,LifePosn_] := 
Block[{},
  If[LifePosn >    LifeLength,Return[0]];
  If[xt == 0                 ,Return[Infinity]];
  If[LifePosn == LifeLength,Return[dudct[xt]]];
  Return[ (VxInvtInterpFunc[[LifePosn]][xt]^(1/VxtToVxInvtPower))
          /VxtToVxInvtMultiply];
];

