rho = 10.;

beta = .95;

wMin = 0;
wMax = 1;
wSteps = 6;

wGrid = Table[wLoop,{wLoop,wMin,wMax,1/(wSteps-1)}] //N;

ePremium = 1.04;
eSig     =  .15;
NumOfeShockPoints = 7;

{eVals,eProb} =  DiscreteApproxToMeanOneLogNormal[eSig,NumOfeShockPoints];
eVals = ePremium eVals;

LifeLength = 20;  (* Number of periods backwards from the end to solve *)

(* List of functions that take savings as their argument *)

NamePosInFunctionList     = 1;
ArgListPosInFunctionList  = 2;

swFunctions  = {
                 {"OmegaInvt"      ,{"s","w"}}
                ,{"OmegasInvt"     ,{"s","w"}}
                ,{"Omegawt"        ,{"s","w"}}                
               };

sFunctions  = {
                 {"OmegaInvOptt"   ,{"s"}}
                ,{"OmegasInvOptt"  ,{"s"}}
                ,{"wt"             ,{"s"}}
               };
               
xFunctions  =  {
                 {"VInvt"        ,{"x"}}
                ,{"VxInvt"       ,{"x"}}
                ,{"ct"           ,{"x"}}
               };

VtToVInvtMultiply = OmegatToOmegaInvtMultiply = OmegaOpttToOmegaInvOpttMultiply = (1-rho);
VtToVInvtPower    = OmegatToOmegaInvtPower    = OmegaOpttToOmegaInvOpttPower    = (1/(1-rho));

VxtToVxInvtMultiply = OmegastToOmegasInvtMultiply = OmegasOpttToOmegasInvOpttMultiply = 1;     
VxtToVxInvtPower    = OmegastToOmegasInvtPower    = OmegasOpttToOmegasInvOpttPower    = -1/rho;

OmegawtToOmegawInvtMultiply = 1;     
OmegawtToOmegawInvtPower    = -1/rho;

FunctionList  = Join[swFunctions,sFunctions,xFunctions];
FunctionNames = Transpose[FunctionList][[NamePosInFunctionList]];

MakeArgArrays[FunctionList];
MakeNewVarByAppendingStringToName[FunctionNames,"InterpData"];
MakeNewVarByAppendingStringToName[FunctionNames,"InterpFunc"];
MakeListFunctions[FunctionList];

