OmegatRaw[st_,LifePosn_] := 
    (1/NumOfyShockPoints)*
	Sum[Vt[R*st+yShockVals[[i]],LifePosn+1],{i,Length[yShockVals]}];

OmegaInvtRaw[st_,LifePosn_] := Block[{},
  If[LifePosn == LifeLength,Return[Infinity]];
  OmegatRawVal = OmegatRaw[st,LifePosn];
  Return[ (OmegatToOmegaInvtMultiply*OmegatRawVal)^OmegatToOmegaInvtPower];
];

Omegat[st_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  Return[(OmegaInvtInterpFunc[[LifePosn]][st]^(1/OmegatToOmegaInvtPower))
         /OmegatToOmegaInvtMultiply];
];
         

OmegaPrimetRaw[st_,LifePosn_] := (1/NumOfyShockPoints)*Sum[R VPrimet[R*st+yShockVals[[i]],LifePosn+1],{i,Length[yShockVals]}];

OmegaInvPrimetRaw[st_,LifePosn_] := Block[{},
  If[LifePosn == LifeLength,Return[Infinity]];
  OmegaPrimetRawVal = OmegaPrimetRaw[st,LifePosn];
  Return[(OmegaPrimetToOmegaInvPrimetMultiply OmegaPrimetRawVal)^OmegaPrimetToOmegaInvPrimetPower]
];

OmegaPrimet[st_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[0]];
  Return[(OmegaInvPrimetInterpFunc[[LifePosn]][st]^(1/OmegaPrimetToOmegaInvPrimetPower))
         /OmegaPrimetToOmegaInvPrimetMultiply]
];


ctRaw[xt_,LifePosn_] := Block[{},
  If[LifePosn >= LifeLength,Return[xt]];
  If[xt < 0, Return[0]];
  ctp1Val = ctRaw[xt,LifePosn+1];
  ctSearchMax = ctp1Val + (xMax-ctp1Val)*.01;
  ctSearchMin = ctp1Val - ctp1Val*.01;
  ctResults = FindRoot[
    ct == (beta OmegaPrimet[xt-ct,LifePosn])^(-1/rho)
  ,{ct,{ctSearchMin,ctSearchMax}}];
  ctUnconstrained = (ct /. ctResults);
  If[ctUnconstrained>xt,xt,ctUnconstrained]
];
  
ct[xt_,LifePosn_] := ctInterpFunc[[LifePosn]][xt];


VInvtRaw[xt_,LifePosn_] := Block[{},
  If[Chop[xt] == 0, Return[0]];
  ctVt = ct[xt,LifePosn];
  VtVal = u[ctVt] + beta Omegat[xt-ctVt,LifePosn]; 
  Return[ (VtVal*VtToVInvtMultiply)^VtToVInvtPower];
];

Vt[xt_,LifePosn_] := Block[{},
  If[LifePosn > LifeLength,Return[0]];
  If[LifePosn == LifeLength,Return[u[xt]]];
  ctVt = ct[xt,LifePosn];
  Return[u[ctVt] + beta Omegat[xt-ctVt,LifePosn]];
];


VInvPrimetRaw[xt_,LifePosn_] := Block[{},
  ctVPrimet = ct[xt,LifePosn];
  Return[ctVPrimet]
];

VPrimet[xt_,LifePosn_] := Block[{},
  If[LifePosn >  LifeLength,Return[0]];
  If[LifePosn == LifeLength,Return[uprime[xt]]];
  Return[uprime[ct[xt,LifePosn]]]
];


